<?php

namespace Larareal\Realestate\Providers;

use Illuminate\Contracts\Auth\Access\Gate as GateContract;
use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * The policy mappings for the package.
     *
     * @var array
     */
    protected $policies = [
        // Bind Property policy
        'Larareal\Realestate\Models\Property' => \Larareal\Realestate\Policies\PropertyPolicy::class,
// Bind PropertyCategory policy
        'Larareal\Realestate\Models\PropertyCategory' => \Larareal\Realestate\Policies\PropertyCategoryPolicy::class,
    ];

    /**
     * Register any package authentication / authorization services.
     *
     * @param \Illuminate\Contracts\Auth\Access\Gate $gate
     *
     * @return void
     */
    public function boot(GateContract $gate)
    {
        parent::registerPolicies($gate);
    }
}
