<?php

namespace Larareal\Realestate;

use User;

class Realestate
{
    /**
     * $property object.
     */
    protected $property;
    /**
     * $property_category object.
     */
    protected $property_category;

    /**
     * Constructor.
     */
    public function __construct(\Larareal\Realestate\Interfaces\PropertyRepositoryInterface $property,
        \Larareal\Realestate\Interfaces\PropertyCategoryRepositoryInterface $property_category)
    {
        $this->property = $property;
        $this->property_category = $property_category;
    }

    /**
     * Returns count of realestate.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.property.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->property->pushCriteria(new \Litepie\Larareal\Repositories\Criteria\PropertyUserCriteria());
        }

        $property = $this->property->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('realestate::' . $view, compact('property'))->render();
    }
    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.property_category.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->property_category->pushCriteria(new \Litepie\Larareal\Repositories\Criteria\PropertyCategoryUserCriteria());
        }

        $property_category = $this->property_category->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('realestate::' . $view, compact('property_category'))->render();
    }
}
